""" python naming convention

Revision ID: bc35a8e1afb8
Revises: 77a70f48c9ab
Create Date: 2022-01-27 13:23:11.196605+01:00

"""
import sqlalchemy as sa
from alembic import op
from alembic_utils.pg_extension import PGExtension
from sqlalchemy.dialects import postgresql

# revision identifiers, used by Alembic.
revision = "bc35a8e1afb8"
down_revision = "77a70f48c9ab"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.rename_table("Setting", "setting")
    op.drop_index("ix_Setting_id", table_name="setting")
    op.drop_index("ix_Setting_name", table_name="setting")
    op.drop_index("ix_Setting_setting_type_id", table_name="setting")
    op.drop_index("ix_Setting_sid", table_name="setting")
    op.create_index(op.f("ix_setting_id"), "setting", ["id"], unique=True)
    op.create_index(op.f("ix_setting_name"), "setting", ["sid"], unique=False)
    op.create_index(op.f("ix_setting_setting_type_id"), "setting", ["sid"], unique=False)
    op.create_index(op.f("ix_setting_sid"), "setting", ["sid"], unique=False)

    op.drop_constraint("Setting_pkey", "setting")
    op.drop_constraint("Setting_uuid_key", "setting")

    op.create_primary_key("setting_pkey", "setting", ["id"])
    op.create_unique_constraint("setting_uuid_key", "setting", ["uuid"])

    op.rename_table("SettingType", "setting_type")
    op.drop_index("ix_SettingType_name", table_name="setting_type")
    op.drop_index("ix_SettingType_sid", table_name="setting_type")

    op.create_index(op.f("ix_setting_type_name"), "setting_type", ["sid"], unique=False)
    op.create_index(op.f("ix_setting_type_sid"), "setting_type", ["sid"], unique=False)
    op.drop_constraint("Setting_setting_type_id_fkey", "setting")

    op.drop_constraint("SettingType_pkey", "setting_type")
    op.drop_constraint("SettingType_uuid_key", "setting_type")

    op.create_primary_key("setting_type_pkey", "setting_type", ["sid"])
    op.create_unique_constraint("setting_type_uuid_key", "setting_type", ["uuid"])
    op.create_foreign_key(
        "sestting_setting_type_id_fkey",
        "setting",
        "setting_type",
        ["setting_type_id"],
        ["sid"],
    )

    op.execute('ALTER SEQUENCE "SettingType_sid_seq" RENAME TO "setting_type_sid_seq"')
    op.execute('ALTER SEQUENCE "Setting_sid_seq" RENAME TO "setting_sid_seq"')
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    public_uuid_ossp = PGExtension(schema="public", signature="uuid-ossp")
    op.create_entity(public_uuid_ossp)

    op.create_table(
        "SettingType",
        sa.Column(
            "sid",
            sa.INTEGER(),
            server_default=sa.text("nextval('\"SettingType_sid_seq\"'::regclass)"),
            autoincrement=True,
            nullable=False,
        ),
        sa.Column(
            "uuid",
            postgresql.UUID(),
            server_default=sa.text("gen_random_uuid()"),
            autoincrement=False,
            nullable=False,
        ),
        sa.Column("name", sa.VARCHAR(), autoincrement=False, nullable=True),
        sa.Column("description", sa.VARCHAR(), autoincrement=False, nullable=True),
        sa.PrimaryKeyConstraint("sid", name="SettingType_pkey"),
        sa.UniqueConstraint("uuid", name="SettingType_uuid_key"),
        postgresql_ignore_search_path=False,
    )
    op.create_index("ix_SettingType_sid", "SettingType", ["sid"], unique=False)
    op.create_index("ix_SettingType_name", "SettingType", ["name"], unique=False)
    op.create_table(
        "Setting",
        sa.Column(
            "sid",
            sa.INTEGER(),
            server_default=sa.text("nextval('\"Setting_sid_seq\"'::regclass)"),
            autoincrement=True,
            nullable=False,
        ),
        sa.Column(
            "id",
            sa.VARCHAR(),
            server_default=sa.text("setting_generate_id()"),
            autoincrement=False,
            nullable=False,
        ),
        sa.Column(
            "uuid",
            postgresql.UUID(),
            server_default=sa.text("gen_random_uuid()"),
            autoincrement=False,
            nullable=False,
        ),
        sa.Column("name", sa.VARCHAR(), autoincrement=False, nullable=True),
        sa.Column("value", sa.VARCHAR(), autoincrement=False, nullable=True),
        sa.Column("description", sa.VARCHAR(), autoincrement=False, nullable=True),
        sa.Column("regex", sa.VARCHAR(), autoincrement=False, nullable=True),
        sa.Column(
            "last_modified",
            postgresql.TIMESTAMP(),
            autoincrement=False,
            nullable=True,
        ),
        sa.Column(
            "setting_type_id",
            sa.INTEGER(),
            autoincrement=False,
            nullable=False,
        ),
        sa.ForeignKeyConstraint(
            ["setting_type_id"],
            ["SettingType.sid"],
            name="Setting_setting_type_id_fkey",
        ),
        sa.PrimaryKeyConstraint("sid", name="Setting_pkey"),
        sa.UniqueConstraint("uuid", name="Setting_uuid_key"),
    )
    op.create_index("ix_Setting_sid", "Setting", ["sid"], unique=False)
    op.create_index(
        "ix_Setting_setting_type_id",
        "Setting",
        ["setting_type_id"],
        unique=False,
    )
    op.create_index("ix_Setting_name", "Setting", ["name"], unique=False)
    op.create_index("ix_Setting_id", "Setting", ["id"], unique=False)
    op.drop_index(op.f("ix_setting_sid"), table_name="setting")
    op.drop_index(op.f("ix_setting_setting_type_id"), table_name="setting")
    op.drop_index(op.f("ix_setting_name"), table_name="setting")
    op.drop_index(op.f("ix_setting_id"), table_name="setting")
    op.drop_table("setting")
    op.drop_index(op.f("ix_setting_type_sid"), table_name="setting_type")
    op.drop_index(op.f("ix_setting_type_name"), table_name="setting_type")
    op.drop_table("setting_type")
    # ### end Alembic commands ###
